/**
 * This is the DEV textIOWrapper.
 * It will handle the actual data IO.
 * It is still in progress
 * @class
 * @in-progress
 */
class textIOWrapper{
  /**
   * Creates the object.
   * @param {URL} input - the input for the problem.
   * @param {URL} output - the output for the problem.
   * @param {object} options - any options in use.
   */
  constructor(input, output, options){
    /**
     * Array of lines of input.
     * @private
     * @type {String[]}
     */
    this.__inputLines = [];
    /**
     * How many lines have been read.
     * @public
     * @type {number}
     * @readonly
     */
    this.linesRead = 0;
    /**
     * Array of lines of output.
     * @private
     * @type {String[]}
     */
    this.__outputLines = [];
    /**
     * How many lines have been sent.
     * @public
     * @type {number}
     * @readonly
     */
    this.linesSent = 0;
    /**
     * Options for the wrapper
     * @public
     * @type {Object}
     * @prop {number} marginOfError The acceptable margin of error. (Will still display warnings)
     * @prop {boolean} isDevelopment If the current wrapper is development or live.
     */
    this.options = options || {};
    this.options.marginOfError || 0;
    this.options.isDevelopment = true;

    console.warn("YOU ARE RUNNING IN DEVELOPMENT, DO NOT SEND THIS CODE!");
  }
  /**
   * Gets a line of input.
   * @public
   * @return {String} The line of input.
   */
  getLine(){
    if(this.linesRead >= this.__inputLines.length){
      this.debugLine("Program will never close, you asked for too many lines.", 4);
    }
    return this.__inputLines[this.linesRead++];
  }
  /**
   * Prints a debug line in dev, won't print anything in live.
   * In LIVE only level 4 will work.
   *
   * Avalible levels:
   * 0. Log
   * 1. Info
   * 2. Warn
   * 3. error
   * 4. throw
   * @public
   * @param {*} message - The message to output.
   * @param {number} [level=0] - The level of message.
   *
   */
  debugLine(message, level=0){
    switch (level) {
      case 0:
        console.log(message);
        break;
      case 1:
        console.info(message);
        break;
      case 2:
        console.warn(message);
        break;
      case 3:
        console.error(message);
        break;
      case 4:
        throw (message);
    }
  }
  /**
   * Prints a line of output.
   * @public
   * @param {String} outputString - A line of output.
   */
  sendLine(outputString){
    if(this.linesSent >= this.__outputLines.length){
      throw "Program returned too many lines."
    }
    __testLine(outputString, this.__outputLines[this.linesSent++]);
  }
  /**
   * Compares two lines of input.
   * @private
   * @param {String} gString - The string that was generated by the program.
   * @param {String} tString - The string to test aganst.
   *
   */
  __testLine(gString, tString){
      let glen = generatedString.length;
      let tlen = testString.length;
      let gpos = 0;
      let tpos = 0;
      let lastgword = "";
      let lasttword = "";
      let lastgchar = "";
      let lasttchar = "";
      let firstPeriod = "";
      while((gpos < glen) && (tpos < tlen)){
        lastgchar = gString[gpos];
        lasttchar = tString[tpos];
        if(lasttchar == " " || lastgchar == " "){
          // end of word.
        }
      }
      let gtrailing = lastgword;
      let ttrailing = lasttword;
      while((gpos < glen) || (tpos < tlen)){
        if(gpos < glen){
          gtrailing += generatedString[gpos++];
        }
        if(tpos < tlen){
          ttrailing += testString[tpos++];
        }
      }
      if(gtrailing !== ""){
        this.debugLine("The following extra trailing characters were on the line" + gtrailing, 3);
      }
      if(ttrailing !== ""){
        this.debugLine("The following characters were missing from the end of the line" + ttrailing, 3);
      }
  }
}
